
$(document).ready(function() {

  
  // position the level-1 menus
  
  $('.tablemenu').each(function(index, element) {
    var tablemenu = element;
    
    $('li.level-0', element).each(function() {
    
      var child = $('ul.level-1', this);
      if (child.length == 0) {
        return;
      }
  
      // the div containing level 0 forms a bounding box,
      // nothing will go outside of it's width
      var boundingBoxLeft = $(tablemenu).position().left;
      var boundingBoxWidth = $(tablemenu).width();
      var boundingBoxTop = $(tablemenu).position().top;
      
      var parentLeft = $(this).position().left;
      var parentWidth = $(this).width();
      var parentTop = $(this).position().top;
      var parentHeight = $(this).height();
      
      var childLeft = child.position().left;
      var childWidth = child.width();
      
      var leftOffset = (parentWidth - childWidth) / 2;
      
      if (parentLeft + leftOffset < boundingBoxLeft) {
        // child is too far left
        leftOffset = boundingBoxLeft - parentLeft;
      } else if (parentLeft + childWidth > boundingBoxWidth) {
        // child is too far right
        leftOffset = parentWidth - childWidth;
      }
  
      // vertical height
      var textDivTop = $('div.level-0', this).position().top;
      var topOffset = parentHeight - (textDivTop - parentTop) + (parentTop - boundingBoxTop);
      
      $('ul.level-1', this).css('left', leftOffset).css('top', topOffset);
      
    });
  });
  
  
  // define some event callbacks for hover and click
  
  
  var hoverIn = function(eventObject) {

    // do nothing if there are no child elements
    // (stops immediate hiding of menu if the user moves sideways)
    var child = $('ul.level-1', this);
    if (child.length == 0) {
      return;
    }
    
    // immediately hide ULs within our siblings 
    $(this).siblings().each(function() {
      $('ul.level-1', this).hide();
    });

    child.show();
  };

  
  var hoverOut = function(eventObject) {
    $('ul.level-1', this).fadeOut('fast');
  };
  
  
  var click = function(eventObject) {
    // do nothing if there are no child elements
    // (stops immediate hiding of menu if the user moves sideways)
    var child = $('ul.level-1', this);
    if (child.length == 0) {
      return;
    }
    
    // immediately hide ULs within our siblings 
    $(this).siblings().each(function() {
      $('ul.level-1', this).hide();
    });

    child.show();
    
    // hide after a short while
    setTimeout(function() {
      child.fadeOut('fast');
    }, 5000);
    
  };
  
  
  $('.tablemenu li.level-0').hoverIntent({
    over: hoverIn,
    out: hoverOut,
    timeout: 500
  });

  $('.tablemenu li.level-0').click(click);
  
});
